//  Painter.cs (v 2)
// Using the mouse to draw on a form.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Generic;

namespace Painter
{
    /// <summary>
    /// creates a form as a drawing surface
    /// </summary>
    public class Painter : System.Windows.Forms.Form
    {
        private Graphics graphics;
        private bool shouldPaint = false;
        private List<Punt> arrayOfPoints;
        private Color kleur = Color.Red;
        private byte size = 4;

        private System.Windows.Forms.Panel drawPanel;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.RadioButton rbRood;
        private System.Windows.Forms.RadioButton rbGeel;
        private System.Windows.Forms.RadioButton rbBlauw;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.RadioButton rbLarge;
        private System.Windows.Forms.RadioButton rbMedium;
        private System.Windows.Forms.RadioButton rbSmall;
        private System.Windows.Forms.Button btnClear; // whether to paint

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        // default constructor
        public Painter()
        {
            InitializeComponent();

            graphics = drawPanel.CreateGraphics();
            arrayOfPoints = new List<Punt>();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }

            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.drawPanel = new System.Windows.Forms.Panel();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.rbRood = new System.Windows.Forms.RadioButton();
            this.rbGeel = new System.Windows.Forms.RadioButton();
            this.rbBlauw = new System.Windows.Forms.RadioButton();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.rbLarge = new System.Windows.Forms.RadioButton();
            this.rbMedium = new System.Windows.Forms.RadioButton();
            this.rbSmall = new System.Windows.Forms.RadioButton();
            this.btnClear = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // drawPanel
            // 
            this.drawPanel.BackColor = System.Drawing.Color.White;
            this.drawPanel.Location = new System.Drawing.Point(112, 16);
            this.drawPanel.Name = "drawPanel";
            this.drawPanel.Size = new System.Drawing.Size(280, 272);
            this.drawPanel.TabIndex = 0;
            this.drawPanel.MouseUp += new System.Windows.Forms.MouseEventHandler(this.Painter_MouseUp);
            this.drawPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.drawPanel_Paint);
            this.drawPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Painter_MouseMove);
            this.drawPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.Painter_MouseDown);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.rbBlauw,
																				  this.rbGeel,
																				  this.rbRood});
            this.groupBox1.Location = new System.Drawing.Point(16, 16);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(80, 96);
            this.groupBox1.TabIndex = 1;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Kleur";
            // 
            // rbRood
            // 
            this.rbRood.Checked = true;
            this.rbRood.Location = new System.Drawing.Point(8, 24);
            this.rbRood.Name = "rbRood";
            this.rbRood.Size = new System.Drawing.Size(64, 16);
            this.rbRood.TabIndex = 0;
            this.rbRood.TabStop = true;
            this.rbRood.Text = "rood";
            this.rbRood.CheckedChanged += new System.EventHandler(this.rbRood_CheckedChanged);
            // 
            // rbGeel
            // 
            this.rbGeel.Location = new System.Drawing.Point(8, 48);
            this.rbGeel.Name = "rbGeel";
            this.rbGeel.Size = new System.Drawing.Size(64, 16);
            this.rbGeel.TabIndex = 1;
            this.rbGeel.Text = "geel";
            this.rbGeel.CheckedChanged += new System.EventHandler(this.rbGeel_CheckedChanged);
            // 
            // rbBlauw
            // 
            this.rbBlauw.Location = new System.Drawing.Point(8, 72);
            this.rbBlauw.Name = "rbBlauw";
            this.rbBlauw.Size = new System.Drawing.Size(64, 16);
            this.rbBlauw.TabIndex = 2;
            this.rbBlauw.Text = "blauw";
            this.rbBlauw.CheckedChanged += new System.EventHandler(this.rbBlauw_CheckedChanged);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.rbLarge,
																				  this.rbMedium,
																				  this.rbSmall});
            this.groupBox2.Location = new System.Drawing.Point(16, 136);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(80, 96);
            this.groupBox2.TabIndex = 3;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Dikte";
            // 
            // rbLarge
            // 
            this.rbLarge.Location = new System.Drawing.Point(8, 72);
            this.rbLarge.Name = "rbLarge";
            this.rbLarge.Size = new System.Drawing.Size(64, 16);
            this.rbLarge.TabIndex = 2;
            this.rbLarge.Text = "large";
            this.rbLarge.CheckedChanged += new System.EventHandler(this.rbLarge_CheckedChanged);
            // 
            // rbMedium
            // 
            this.rbMedium.Checked = true;
            this.rbMedium.Location = new System.Drawing.Point(8, 48);
            this.rbMedium.Name = "rbMedium";
            this.rbMedium.Size = new System.Drawing.Size(64, 16);
            this.rbMedium.TabIndex = 1;
            this.rbMedium.TabStop = true;
            this.rbMedium.Text = "medium";
            this.rbMedium.CheckedChanged += new System.EventHandler(this.rbMedium_CheckedChanged);
            // 
            // rbSmall
            // 
            this.rbSmall.Location = new System.Drawing.Point(8, 24);
            this.rbSmall.Name = "rbSmall";
            this.rbSmall.Size = new System.Drawing.Size(64, 16);
            this.rbSmall.TabIndex = 0;
            this.rbSmall.Text = "small";
            this.rbSmall.CheckedChanged += new System.EventHandler(this.rbSmall_CheckedChanged);
            // 
            // btnClear
            // 
            this.btnClear.Location = new System.Drawing.Point(24, 256);
            this.btnClear.Name = "btnClear";
            this.btnClear.TabIndex = 4;
            this.btnClear.Text = "Clear";
            this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
            // 
            // Painter
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(408, 301);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		this.btnClear,
																		this.groupBox2,
																		this.groupBox1,
																		this.drawPanel});
            this.Name = "Painter";
            this.Text = "Painter(2)";
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.ResumeLayout(false);

        } // end method InitializeComponent

        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Painter());
        }

        // should paint after mouse button has been pressed
        private void Painter_MouseDown(
           object sender, System.Windows.Forms.MouseEventArgs e)
        {
            shouldPaint = true;
        }

        // stop painting when mouse button released
        private void Painter_MouseUp(
           object sender, System.Windows.Forms.MouseEventArgs e)
        {
            shouldPaint = false;
        }

        // draw circle whenever mouse button 
        // moves (and mouse is down)
        protected void Painter_MouseMove(
           object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (shouldPaint)
            {
                arrayOfPoints.Add(new Punt(
                    kleur, size,
                    new Point(e.X, e.Y)));
                graphics.FillEllipse(
                   new SolidBrush(kleur),
                   e.X, e.Y, size, size);
            }

        }

        private void drawPanel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            foreach (Punt p in arrayOfPoints)
            {
                graphics.FillEllipse(new SolidBrush(p.Kleur),
                    p.Positie.X, p.Positie.Y, p.Dikte, p.Dikte);
            }
        }

        private void rbRood_CheckedChanged(object sender, System.EventArgs e)
        {
            kleur = Color.Red;
        }

        private void rbGeel_CheckedChanged(object sender, System.EventArgs e)
        {
            kleur = Color.Yellow;
        }

        private void rbBlauw_CheckedChanged(object sender, System.EventArgs e)
        {
            kleur = Color.Blue;
        }

        private void rbSmall_CheckedChanged(object sender, System.EventArgs e)
        {
            size = 2;
        }

        private void rbMedium_CheckedChanged(object sender, System.EventArgs e)
        {
            size = 4;
        }

        private void rbLarge_CheckedChanged(object sender, System.EventArgs e)
        {
            size = 6;
        }

        private void btnClear_Click(object sender, System.EventArgs e)
        {
            graphics.Clear(Color.White);
            arrayOfPoints.Clear();
        }

    } // end class Painter

    class Punt
    {
        private Color kleur;
        private byte dikte;
        private Point punt;

        public Punt(Color kleur, byte dikte, Point point)
        {
            Kleur = kleur;
            Dikte = dikte;
            Positie = point;
        }

        public Color Kleur
        {
            get { return kleur; }
            set { kleur = value; }
        }

        public Point Positie
        {
            get { return punt; }
            set { punt = value; }
        }

        public byte Dikte
        {
            get { return dikte; }
            set { dikte = value; }
        }

    }
} // end namespace Painter